import java.io.*;
import java.util.ArrayList;

import javax.swing.JTree;
import javax.swing.tree.DefaultMutableTreeNode;
import javax.xml.parsers.DocumentBuilder;
import javax.xml.parsers.DocumentBuilderFactory;
import javax.xml.parsers.SAXParser;
import javax.xml.parsers.SAXParserFactory;

import org.w3c.dom.*;
/**
 * Provide some services for reading xml documents.
 * 
 * @author TRUNG, N.V
 *
 */
public class XMLReader {
	/**
	 * Get the document as the result of parsing an XML file.
	 * @param String xmlFile: absolute path to the XML file  
	 * @return: a document  
	 */
	public static Document getDocument(String xmlFile) {
		DocumentBuilderFactory factory = DocumentBuilderFactory.newInstance();
		try {
			DocumentBuilder builder = factory.newDocumentBuilder();
			Document doc = builder.parse(new File(xmlFile));
			return doc;
		} catch (Exception e) {
			System.err.println(e.getMessage());
			e.printStackTrace();
		}
		return null;
	}
}
