/*************************************************************************** 
 * pbus-test/pseudo-linux/pseudo_linux_define.h 2009-03-20                 *
 * Copyright (C) 2007-2009 A.N.LAB JSC, Hanoi, Vietnam                     *
 * Define The Pseudo Linux Kernel for PBUS component testing               *
 ***************************************************************************/

#ifndef PSEUDO_LINUX_DEFINE_H
#define PSEUDO_LINUX_DEFINE_H

#define INT_MAX         255//((int)(~0U>>1))
#define va_list const char *

/*static int printk(const char *fmt, ...)
{
        return 0;
}
*/
#define NULL 0
#define AF_INET         2       /* Internet IP Protocol         */

typedef unsigned long   __kernel_ino_t;
typedef unsigned short  __kernel_mode_t;
typedef unsigned short  __kernel_nlink_t;
typedef long            __kernel_off_t;
typedef int             __kernel_pid_t;
typedef unsigned short  __kernel_ipc_pid_t;
typedef unsigned short  __kernel_uid_t;
typedef unsigned short  __kernel_gid_t;
typedef unsigned int    __kernel_size_t;
typedef int             __kernel_ssize_t;
typedef int             __kernel_ptrdiff_t;
typedef long            __kernel_time_t;
typedef long            __kernel_suseconds_t;
typedef long            __kernel_clock_t;
typedef int             __kernel_timer_t;
typedef int             __kernel_clockid_t;
typedef int             __kernel_daddr_t;
typedef char *          __kernel_caddr_t;
typedef unsigned short  __kernel_uid16_t;
typedef unsigned short  __kernel_gid16_t;
typedef unsigned int    __kernel_uid32_t;
typedef unsigned int    __kernel_gid32_t;
typedef unsigned short  __kernel_old_uid_t;
typedef unsigned short  __kernel_old_gid_t;
typedef unsigned short  __kernel_old_dev_t;
 

struct lock_class_key {
   int pseudo;
};

struct lock_class {
   int pseudo;
};

struct lockdep_map {
        struct lock_class_key           *key;
        struct lock_class               *class_cache;
        const char                      *name;
        int                             cpu;
};



typedef struct {
        unsigned int slock;
} raw_spinlock_t;

typedef struct {
        unsigned int lock;
} raw_rwlock_t;

typedef struct {
        raw_rwlock_t raw_lock;
        unsigned int break_lock;
        unsigned int magic, owner_cpu;
        void *owner;
        struct lockdep_map dep_map;
} rwlock_t;

typedef struct {
        raw_spinlock_t raw_lock;
        unsigned int break_lock;
        unsigned int magic, owner_cpu;
        void *owner;
        struct lockdep_map dep_map; 
} spinlock_t;

struct list_head {
        struct list_head *next, *prev;
};

struct rw_semaphore {
        long                    count;
#define RWSEM_UNLOCKED_VALUE            0x0000000000000000L
#define RWSEM_ACTIVE_BIAS               0x0000000000000001L
#define RWSEM_ACTIVE_MASK               0x00000000ffffffffL
#define RWSEM_WAITING_BIAS              (-0x0000000100000000L)
#define RWSEM_ACTIVE_READ_BIAS          RWSEM_ACTIVE_BIAS
#define RWSEM_ACTIVE_WRITE_BIAS         (RWSEM_WAITING_BIAS + RWSEM_ACTIVE_BIAS)
        spinlock_t              wait_lock;
        struct list_head        wait_list;
};

//define cho file pbus/slab.h
#define RWLOCK_MAGIC            0xdeaf1eed
#define SPINLOCK_OWNER_INIT     ((void *)-1L)
#define RW_DEP_MAP_INIT(lockname) 0
#define __RAW_RW_LOCK_UNLOCKED 0
#define __RW_LOCK_UNLOCKED(lockname)                                    \
        (rwlock_t)      {       .raw_lock = __RAW_RW_LOCK_UNLOCKED,     \
                                .magic = RWLOCK_MAGIC,                  \
                                .owner = SPINLOCK_OWNER_INIT,           \
                                .owner_cpu = -1,                        \
                                RW_DEP_MAP_INIT(lockname) }
#define GFP_KERNEL 1
#define GFP_NOWAIT 1000         // big enough to be distinguished
#define __GFP_ZERO 2
#define GFP_ATOMIC 3
#define GFP_NOIO   4
#define GFP_NOFS   5
#define GFP_KERNEL 6
#define GFP_TEMPORARY 7
#define GFP_USER      8
#define GFP_HIGHUSER  9
#define GFP_HIGHUSER_MOVABLE 10
#define GFP_NOFS_PAGECACHE   11
#define GFP_USER_PAGECACHE   12
#define GFP_HIGHUSER_PAGECACHE  13
#define __bitwise__ __attribute__((bitwise))
typedef unsigned __bitwise__ gfp_t;
typedef unsigned size_t;
typedef unsigned int  __u16;
typedef unsigned int  __u32;
typedef unsigned int  __u8;
typedef unsigned int  __be16;
typedef unsigned int  __be32;
typedef unsigned int  __be64; 
typedef unsigned char  u8;
typedef unsigned int  u16;
typedef unsigned int  u32;

#define NULL 0
#define MAX_NUMNODES 100
#define NR_CPUS 2

/* unistd.h */
#define __NR_mkdir               39
#define __NR_rmdir               40

/**/
typedef struct {
         int counter;
} atomic_t;

typedef atomic_t atomic_long_t;

#define ATOMIC_INIT(i)  { (i) }

struct kobject {
        const char              * k_name;
        unsigned                kref;
        unsigned                entry;
        struct kobject          * parent;
        unsigned                * kset;
        unsigned                * ktype;
        unsigned                * sd;
};

struct kmem_cache_cpu {
        void **freelist;
        struct page *page;
        int node;
        unsigned int offset;
        unsigned int objsize;
};

struct kmem_cache_node {
        spinlock_t list_lock;   /* Protect partial list and nr_partial */
        unsigned long nr_partial;
        atomic_long_t nr_slabs;
        struct list_head partial;
        struct list_head full;
};

struct kmem_cache {
        /* Used for retriving partial slabs etc */
        unsigned long flags;
        int size;               /* The size of an object including meta data */
        int objsize;            /* The size of an object without meta data */
        int offset;             /* Free pointer offset. */
        int order;

        /*
         * Avoid an extra cache line for UP, SMP and for the node local to
         * struct kmem_cache.
         */
        struct kmem_cache_node local_node;

        /* Allocation and freeing of slabs */
        int objects;            /* Number of objects in slab */
        int refcount;           /* Refcount for slab cache destroy */
        void (*ctor)(struct kmem_cache *, void *);
        int inuse;              /* Offset to metadata */
        int align;              /* Alignment */
        const char *name;       /* Name (only for display!) */
        struct list_head list;  /* List of slab caches */
        struct kobject kobj;    /* For sysfs */
        int defrag_ratio;
        struct kmem_cache_node *node[MAX_NUMNODES];
        struct kmem_cache_cpu cpu_slab;
};

struct kmem_cache *kmem_cache_create(const char *, size_t, size_t, unsigned long, void (*)(struct kmem_cache *, void *));

void *kmem_cache_alloc(struct kmem_cache *, gfp_t);

/*define cho file pbus/thread.h*/
#define TASK_RUNNING            0
#define TASK_INTERRUPTIBLE      1
#define TASK_UNINTERRUPTIBLE    2
#define TASK_STOPPED            4
#define TASK_TRACED             8
/* in tsk->exit_state */
#define EXIT_ZOMBIE             16
#define EXIT_DEAD               32
/* in tsk->state again */
#define TASK_DEAD               64

struct module
 {
/*         enum module_state state;
 
 
        struct list_head list;
 
 
         char name[MODULE_NAME_LEN];
 
         struct module_kobject mkobj;
         struct module_param_attrs *param_attrs;
         struct module_attribute *modinfo_attrs;*/
         const char *version;
         const char *srcversion;
 /*        struct kobject *holders_dir;
 
 
         const struct kernel_symbol *syms;*/
         unsigned int num_syms;
         const unsigned long *crcs;

/*        const struct kernel_symbol *gpl_syms;*/
        unsigned int num_gpl_syms;
        const unsigned long *gpl_crcs;


/*        const struct kernel_symbol *unused_syms;*/
        unsigned int num_unused_syms;
        const unsigned long *unused_crcs;

/* 282        const struct kernel_symbol *unused_gpl_syms;
 283        unsigned int num_unused_gpl_syms;
 284        const unsigned long *unused_gpl_crcs;
 285

 287        const struct kernel_symbol *gpl_future_syms;
 288        unsigned int num_gpl_future_syms;
 289        const unsigned long *gpl_future_crcs;
 290

 292        unsigned int num_exentries;
 293        const struct exception_table_entry *extable;
 294

 296        int (*init)(void);
 297

 299        void *module_init;
 300

 302        void *module_core;
 303

 305        unsigned long init_size, core_size;
 306

 308        unsigned long init_text_size, core_text_size;
 309

 311        void *unwind_info;
 312

 314        struct mod_arch_specific arch;
 315
 316        unsigned int taints;   
 317
 318#ifdef CONFIG_GENERIC_BUG

 320        struct list_head bug_list;
 321        struct bug_entry *bug_table;
 322        unsigned num_bugs;
 323#endif
 324
 325#ifdef CONFIG_MODULE_UNLOAD

 327        struct module_ref ref[NR_CPUS];
 328

 330        struct list_head modules_which_use_me;
 331

 333        struct task_struct *waiter;
 334

 336        void (*exit)(void);
 337#endif
 338
 339#ifdef CONFIG_KALLSYMS

 341        Elf_Sym *symtab;
 342        unsigned long num_symtab;
 343        char *strtab;
 344

 346        struct module_sect_attrs *sect_attrs;
 347

 349        struct module_notes_attrs *notes_attrs;
 350#endif
 351

 353        void *percpu;
 354
 357        char *args;
 358#ifdef CONFIG_MARKERS
 359        struct marker *markers;
 360        unsigned int num_markers;
 361#endif*/
};

struct task_struct {
       volatile long state;    /* -1 unrunnable, 0 runnable, >0 stopped */
       void *stack;
       atomic_t usage;
       unsigned int flags;     /* per process flags, defined below */
       unsigned int ptrace;

       int lock_depth;         /* BKL lock depth */
/*
#ifdef CONFIG_SMP
#ifdef __ARCH_WANT_UNLOCKED_CTXSW
        int oncpu;
#endif
#endif

        int prio, static_prio, normal_prio;
        struct list_head run_list;
        const struct sched_class *sched_class;
        struct sched_entity se;

#ifdef CONFIG_PREEMPT_NOTIFIERS

        struct hlist_head preempt_notifiers;
#endif
*/
        unsigned short ioprio;
        unsigned char fpu_counter;
/*        s8 oomkilladj;
#ifdef CONFIG_BLK_DEV_IO_TRACE
        unsigned int btrace_seq;
#endif
*/
        unsigned int policy;
/*        cpumask_t cpus_allowed;*/
        unsigned int time_slice;

/*#if defined(CONFIG_SCHEDSTATS) || defined(CONFIG_TASK_DELAY_ACCT)
       struct sched_info sched_info;
#endif

        struct list_head tasks;
        struct list_head ptrace_children;
        struct list_head ptrace_list;
        struct mm_struct *mm, *active_mm;

 struct linux_binfmt *binfmt;*/
        int exit_state;
        int exit_code, exit_signal;
        int pdeath_signal; 
        unsigned int personality;
        unsigned did_exec:1;
/*        pid_t pid;
        pid_t tgid;

#ifdef CONFIG_CC_STACKPROTECTOR
        unsigned long stack_canary;
#endif
*/
/*       struct task_struct *real_parent;
       struct task_struct *parent;

       struct list_head children;      
       struct list_head sibling;       
       struct task_struct *group_leader;

       struct pid_link pids[PIDTYPE_MAX];
       struct list_head thread_group;
       struct completion *vfork_done;  
       int __user *set_child_tid;      
       int __user *clear_child_tid;    
       unsigned int rt_priority;
       cputime_t utime, stime, utimescaled, stimescaled;
       cputime_t gtime;
       cputime_t prev_utime, prev_stime;
       unsigned long nvcsw, nivcsw; 
       struct timespec start_time;  
       struct timespec real_start_time;

       unsigned long min_flt, maj_flt;

       cputime_t it_prof_expires, it_virt_expires;
       unsigned long long it_sched_expires;
       struct list_head cpu_timers[3];

       uid_t uid,euid,suid,fsuid;
       gid_t gid,egid,sgid,fsgid;
       struct group_info *group_info;
       kernel_cap_t   cap_effective, cap_inheritable, cap_permitted;
       unsigned keep_capabilities:1;
       struct user_struct *user;
#ifdef CONFIG_KEYS
       struct key *request_key_auth; 
       struct key *thread_keyring;   
       unsigned char jit_keyring;    
#endif
       char comm[TASK_COMM_LEN];
                                
       int link_count, total_link_count;
#ifdef CONFIG_SYSVIPC

#endif

        struct thread_struct thread;

        struct fs_struct *fs;

        struct files_struct *files;

        struct nsproxy *nsproxy;

        struct signal_struct *signal;
        struct sighand_struct *sighand;

        sigset_t blocked, real_blocked;
        sigset_t saved_sigmask; 
        struct sigpending pending;

        unsigned long sas_ss_sp;
        size_t sas_ss_size;
        int (*notifier)(void *priv);
        void *notifier_data;
        sigset_t *notifier_mask;
#ifdef CONFIG_SECURITY
        void *security;
#endif
        struct audit_context *audit_context;
        seccomp_t seccomp;


        u32 parent_exec_id;
        u32 self_exec_id;

        spinlock_t alloc_lock;

        spinlock_t pi_lock;

#ifdef CONFIG_RT_MUTEXES

       struct plist_head pi_waiters;

       struct rt_mutex_waiter *pi_blocked_on;
#endif
#ifdef CONFIG_DEBUG_MUTEXES
       struct mutex_waiter *blocked_on;
#endif
#ifdef CONFIG_TRACE_IRQFLAGS
        unsigned int irq_events;
        int hardirqs_enabled;
        unsigned long hardirq_enable_ip;
        unsigned int hardirq_enable_event;
        unsigned long hardirq_disable_ip;
        unsigned int hardirq_disable_event;
        int softirqs_enabled;
        unsigned long softirq_disable_ip;
        unsigned int softirq_disable_event;
        unsigned long softirq_enable_ip;
        unsigned int softirq_enable_event;
        int hardirq_context;
        int softirq_context;
#endif
#ifdef CONFIG_LOCKDEP
# define MAX_LOCK_DEPTH 30UL
        u64 curr_chain_key;
        int lockdep_depth;
        struct held_lock held_locks[MAX_LOCK_DEPTH];
        unsigned int lockdep_recursion;
#endif
        void *journal_info;
        struct bio *bio_list, **bio_tail;
        struct reclaim_state *reclaim_state;
        struct backing_dev_info *backing_dev_info;
        struct io_context *io_context;
        unsigned long ptrace_message;
        siginfo_t *last_siginfo;
#ifdef CONFIG_TASK_XACCT
        u64 rchar, wchar, syscr, syscw;
#endif
        struct task_io_accounting ioac;
#if defined(CONFIG_TASK_XACCT)
        u64 acct_rss_mem1;
        u64 acct_vm_mem1; 
        cputime_t acct_stimexpd;
#endif
#ifdef CONFIG_NUMA
        struct mempolicy *mempolicy;
        short il_next;
#endif
#ifdef CONFIG_CPUSETS
        nodemask_t mems_allowed;
        int cpuset_mems_generation;
        int cpuset_mem_spread_rotor;
#endif
#ifdef CONFIG_CGROUPS
       struct css_set *cgroups;
       struct list_head cg_list;
#endif
#ifdef CONFIG_FUTEX
       struct robust_list_head __user *robust_list;
#ifdef CONFIG_COMPAT
       struct compat_robust_list_head __user *compat_robust_list;
#endif
       struct list_head pi_state_list;
       struct futex_pi_state *pi_state_cache;
#endif
       atomic_t fs_excl;
       struct rcu_head rcu;
       struct pipe_inode_info *splice_pipe;
#ifdef  CONFIG_TASK_DELAY_ACCT
        struct task_delay_info *delays;
#endif
#ifdef CONFIG_FAULT_INJECTION
        int make_it_fail;
#endif
        struct prop_local_single dirties;*/
};
/****** net/sock.h *****/
/*
struct sock {
        
        struct sock_common      __sk_common;
#define sk_family               __sk_common.skc_family
#define sk_state                __sk_common.skc_state
#define sk_reuse                __sk_common.skc_reuse
#define sk_bound_dev_if         __sk_common.skc_bound_dev_if
#define sk_node                 __sk_common.skc_node
#define sk_bind_node            __sk_common.skc_bind_node
#define sk_refcnt               __sk_common.skc_refcnt
#define sk_hash                 __sk_common.skc_hash
#define sk_prot                 __sk_common.skc_prot
#define sk_net                  __sk_common.skc_net
        unsigned char           sk_shutdown : 2,
                                sk_no_check : 2,
                                sk_userlocks : 4;
        unsigned char           sk_protocol;
        unsigned short          sk_type;
        int                     sk_rcvbuf;
        socket_lock_t           sk_lock;

        struct {
                struct sk_buff *head;
                struct sk_buff *tail;
        } sk_backlog;
        wait_queue_head_t       *sk_sleep;
        struct dst_entry        *sk_dst_cache;
        struct xfrm_policy      *sk_policy[2];
        rwlock_t                sk_dst_lock;
        atomic_t                sk_rmem_alloc;
        atomic_t                sk_wmem_alloc;
        atomic_t                sk_omem_alloc;
        int                     sk_sndbuf;
        struct sk_buff_head     sk_receive_queue;
        struct sk_buff_head     sk_write_queue;
        struct sk_buff_head     sk_async_wait_queue;
        int                     sk_wmem_queued;
        int                     sk_forward_alloc;
        gfp_t                   sk_allocation;
        int                     sk_route_caps;
        int                     sk_gso_type;
        int                     sk_rcvlowat;
        unsigned long           sk_flags;
        unsigned long           sk_lingertime;
        struct sk_buff_head     sk_error_queue;
        struct proto            *sk_prot_creator;
        rwlock_t                sk_callback_lock;
        int                     sk_err,
                                sk_err_soft;
        unsigned short          sk_ack_backlog;
        unsigned short          sk_max_ack_backlog;
        __u32                   sk_priority;
        struct ucred            sk_peercred;
        long                    sk_rcvtimeo;
        long                    sk_sndtimeo;
        struct sk_filter        *sk_filter;
        void                    *sk_protinfo;
        struct timer_list       sk_timer;
        ktime_t                 sk_stamp;
        struct socket           *sk_socket;
        void                    *sk_user_data;
        struct page             *sk_sndmsg_page;
        struct sk_buff          *sk_send_head;
        __u32                   sk_sndmsg_off;
        int                     sk_write_pending;
        void                    *sk_security;
        void                    (*sk_state_change)(struct sock *sk);
        void                    (*sk_data_ready)(struct sock *sk, int bytes);
        void                    (*sk_write_space)(struct sock *sk);
        void                    (*sk_error_report)(struct sock *sk);
        int                     (*sk_backlog_rcv)(struct sock *sk,
                                                  struct sk_buff *skb);  
        void                    (*sk_destruct)(struct sock *sk);
};
*/

/*************************************/
/*define cho pbus/time.h*/
typedef unsigned long time_t;
typedef unsigned long suseconds_t;
struct timespec {
        time_t  tv_sec;         /* seconds */
        long    tv_nsec;        /* nanoseconds */
};
struct timeval {
        time_t          tv_sec;         /* seconds */
        suseconds_t     tv_usec;        /* microseconds */
};

/*define cho timer.h*/
struct timer_list {
/*        struct list_head entry;*/
        unsigned long expires;

        /*void (*function)(unsigned long);
        unsigned long data;

        struct tvec_t_base_s *base;*/
        void *start_site;
        char start_comm[16];
        int start_pid;
};

struct hrtimer {
/*        struct rb_node                  node;
        ktime_t                         expires;
        enum hrtimer_restart            (*function)(struct hrtimer *);
        struct hrtimer_clock_base       *base;*/
        unsigned long                   state;
/*#ifdef CONFIG_HIGH_RES_TIMERS
        enum hrtimer_cb_mode            cb_mode;
        struct list_head                cb_entry;
#endif
#ifdef CONFIG_TIMER_STATS
        void                            *start_site;
        char                            start_comm[16];
        int                             start_pid;
#endif*/
};
/*define cho pbus/uki.h*/
typedef unsigned long mode_t;
typedef unsigned long ssize_t;
typedef unsigned long loff_t;
struct attribute {
        const char              *name;
        struct module           *owner;
        mode_t                  mode;
};

struct file {
        atomic_t                f_count;
        unsigned int            f_flags;
        mode_t                  f_mode;
        loff_t                  f_pos;
        unsigned int            f_uid, f_gid;
        void                    *f_security;
        void                    *private_data;
        spinlock_t              f_ep_lock;
};

struct bin_attribute {
        struct attribute        attr;
        size_t                  size;
        void                    *private;
        ssize_t (*read)(struct kobject *, struct bin_attribute *,
                        char *, loff_t, size_t);
        ssize_t (*write)(struct kobject *, struct bin_attribute *,
                         char *, loff_t, size_t);
       /* int (*mmap)(struct kobject *, struct bin_attribute *attr,
                    struct vm_area_struct *vma);*/
};
/*define cho pbus/chrdev.h*/
struct file_operations {
        struct module *owner;
        ssize_t (*read) (/*struct file *, char *, size_t, loff_t **/);
        ssize_t (*write) (/*struct file *, const char *, size_t, loff_t **/);
        int (*ioctl) (/*struct inode *, struct file *, unsigned int, unsigned long*/);
        int (*open) (/*struct inode *, struct file **/);
        int (*release) (/*struct inode *, struct file **/);
};
/*define cho netif.h*/
#define IFF_UP          0x1             /* interface is up              */
#define IFF_BROADCAST   0x2             /* broadcast address valid      */
#define IFF_DEBUG       0x4             /* turn on debugging            */
#define IFF_LOOPBACK    0x8             /* is a loopback net            */
#define IFF_POINTOPOINT 0x10            /* interface is has p-p link    */
#define IFF_NOTRAILERS  0x20            /* avoid use of trailers        */
#define IFF_RUNNING     0x40            /* interface RFC2863 OPER_UP    */
#define IFF_NOARP       0x80            /* no ARP protocol              */
#define IFF_PROMISC     0x100           /* receive all packets          */
#define IFF_ALLMULTI    0x200           /* receive all multicast packets*/

#define IFF_MASTER      0x400           /* master of a load balancer    */
#define IFF_SLAVE       0x800           /* slave of a load balancer     */

#define IFF_MULTICAST   0x1000          /* Supports multicast           */

#define IFF_PORTSEL     0x2000          /* can set media type           */
#define IFF_AUTOMEDIA   0x4000          /* auto media select active     */
#define IFF_DYNAMIC     0x8000          /* dialup device with changing addresses*/

#define IFF_LOWER_UP    0x10000         /* driver signals L1 up         */
#define IFF_DORMANT     0x20000         /* driver signals dormant       */
#define IFNAMSIZ        200
#define MAX_ADDR_LEN    100

struct net_device_stats
{
        unsigned long   rx_packets;             /* total packets received       */
        unsigned long   tx_packets;             /* total packets transmitted    */
        unsigned long   rx_bytes;               /* total bytes received         */
        unsigned long   tx_bytes;               /* total bytes transmitted      */
        unsigned long   rx_errors;              /* bad packets received         */
        unsigned long   tx_errors;              /* packet transmit problems     */
        unsigned long   rx_dropped;             /* no space in linux buffers    */
        unsigned long   tx_dropped;             /* no space available in linux  */
        unsigned long   multicast;              /* multicast packets received   */
        unsigned long   collisions;

        /* detailed rx_errors: */
        unsigned long   rx_length_errors;
        unsigned long   rx_over_errors;         /* receiver ring buff overflow  */
        unsigned long   rx_crc_errors;          /* recved pkt with crc error    */
        unsigned long   rx_frame_errors;        /* recv'd frame alignment error */
        unsigned long   rx_fifo_errors;         /* recv'r fifo overrun          */
        unsigned long   rx_missed_errors;       /* receiver missed packet       */

        /* detailed tx_errors */
        unsigned long   tx_aborted_errors;
        unsigned long   tx_carrier_errors;
        unsigned long   tx_fifo_errors;
        unsigned long   tx_heartbeat_errors;
        unsigned long   tx_window_errors;
        
        /* for cslip etc */
        unsigned long   rx_compressed;
        unsigned long   tx_compressed;
};

struct net_device;
/*define cho pbus/netbuf.h*/
//#ifdef NET_SKBUFF_DATA_USES_OFFSET
typedef unsigned int sk_buff_data_t;
//#else
//typedef unsigned char *sk_buff_data_t;
//#endif

struct sk_buff {
         /* These two members must be first. */
         struct sk_buff          *next;
         struct sk_buff          *prev;
 
         //struct sock             *sk;
         //ktime_t                 tstamp;
         struct net_device       *dev;
         char                    cb[48];
 
         unsigned int            len,
                                 data_len;
         __u16                   mac_len,
                                 hdr_len;
         __u32                   priority;
         __u8                    local_df:1,
                                 cloned:1,
                                 ip_summed:2,
                                 nohdr:1,
                                 nfctinfo:3;
         __u8                    pkt_type:3,
                                 fclone:2,
                                 ipvs_property:1,
                                 nf_trace:1;
         __be16                  protocol;
 
         void                    (*destructor)(struct sk_buff *skb);
        sk_buff_data_t          transport_header;
        sk_buff_data_t          network_header;
        sk_buff_data_t          mac_header;


        sk_buff_data_t          tail;
        sk_buff_data_t          end;
        unsigned char           *head,
                                *data;
        unsigned int            truesize;
        atomic_t                users;
 };

struct net_device
{
       char                    name[IFNAMSIZ];
       unsigned long           mem_end;        /* shared mem end       */
       unsigned long           mem_start;      /* shared mem start     */
       unsigned long           base_addr;      /* device I/O address   */
       unsigned int            irq;            /* device IRQ number    */
       unsigned char           if_port;        /* Selectable AUI, TP,..*/
       unsigned char           dma;            /* DMA channel          */
       unsigned long           state;
       unsigned long           status;
       int                     (*init)(struct net_device *dev);
       unsigned long           features;
 #define NETIF_F_SG              1       /* Scatter/gather IO. */
 #define NETIF_F_IP_CSUM         2       /* Can checksum TCP/UDP over IPv4. */
 #define NETIF_F_NO_CSUM         4       /* Does not require checksum. F.e. loopack. */
 #define NETIF_F_HW_CSUM         8       /* Can checksum all the packets. */
 #define NETIF_F_IPV6_CSUM       16      /* Can checksum TCP/UDP over IPV6 */
 #define NETIF_F_HIGHDMA         32      /* Can DMA to high memory. */
 #define NETIF_F_FRAGLIST        64      /* Scatter/gather IO. */
 #define NETIF_F_HW_VLAN_TX      128     /* Transmit VLAN hw acceleration */
 #define NETIF_F_HW_VLAN_RX      256     /* Receive VLAN hw acceleration */
 #define NETIF_F_HW_VLAN_FILTER  512     /* Receive filtering on VLAN */
 #define NETIF_F_VLAN_CHALLENGED 1024    /* Device cannot handle VLAN packets */
 #define NETIF_F_GSO             2048    /* Enable software GSO. */
 #define NETIF_F_LLTX            4096    /* LockLess TX - deprecated. Please */
                                         /* do not use LLTX in new drivers */
 #define NETIF_F_NETNS_LOCAL     8192    /* Does not change network namespaces */
 #define NETIF_F_MULTI_QUEUE     16384   /* Has multiple TX/RX queues */
 #define NETIF_F_LRO             32768   /* large receive offload */
 
         struct net_device       *next_sched;

         /* Interface index. Unique device identifier    */
         int                     ifindex;
         int                     iflink;
        struct net_device_stats stats;  
        void                    *priv;
        unsigned long           data;
        unsigned int            flags;  /* interface flags (a la BSD)   */
        unsigned short          gflags;
        unsigned short          priv_flags; /* Like 'flags' but invisible to userspace. */
        unsigned short          padded; /* How much padding added by alloc_netdev() */

        unsigned char           operstate; /* RFC2863 operstate */
        unsigned char           link_mode; /* mapping policy to operstate */
        unsigned char           *dev_addr;
        unsigned                mtu;    /* interface MTU value          */
        unsigned short          type;   /* interface hardware type      */
        unsigned short          hard_header_len;        /* hardware hdr length  */

        struct net_device       *master; /* Pointer to master device of a group,
                                          * which this device is member of.
                                          */

        /* Interface address info. */
        unsigned char           perm_addr[MAX_ADDR_LEN]; /* permanent hw address */
        unsigned char           addr_len;       /* hardware address length      */
        unsigned short          dev_id;         /* for shared network cards */
        struct net_device       *link_watch_next;
};

struct header_ops {
       int     (*create) (struct sk_buff *skb, struct net_device *dev,
                           unsigned short type, const void *daddr,
                           const void *saddr, unsigned len);
        int     (*parse)(const struct sk_buff *skb, unsigned char *haddr);
        int     (*rebuild)(struct sk_buff *skb);
#define HAVE_HEADER_CACHE
        int     (*cache)(const struct neighbour *neigh, struct hh_cache *hh);
        void    (*cache_update)(struct hh_cache *hh,
                                const struct net_device *dev,
                               const unsigned char *haddr);
};


/*#define rx_packets  "rx_packets"
#define tx_packets  "tx_packets"
#define rx_bytes "rx_bytes"
#define tx_bytes "tx_bytes"
#define rx_errors "rx_errors"
#define tx_errors "tx_errors"
#define rx_dropped "rx_dropped"
#define tx_dropped "tx_dropped"
#define multicast "multicast"
#define collisions "collisions"*/
struct iovec
{
        void  *iov_base;  /* BSD uses caddr_t (1003.1g requires void *) */
        unsigned long iov_len; /* Must be size_t (1003.1g) */
};
struct sk_buff_head {
        /* These two members must be first. */
        struct sk_buff  *next;
        struct sk_buff  *prev;

        __u32           qlen;
        spinlock_t      lock;
};
typedef unsigned int off_t; 
typedef unsigned int uint16_t;
typedef unsigned int uint32_t;
/*define cho file pbus/netl3.h*/
#define NET_RX_SUCCESS          0   /* keep 'em coming, baby */
#define NET_RX_DROP             1  /* packet dropped */
#define NET_RX_CN_LOW           2   /* storm alert, just in case */
#define NET_RX_CN_MOD           3   /* Storm on its way! */
#define NET_RX_CN_HIGH          4   /* The storm is here */
#define NET_RX_BAD              5  /* packet dropped due to kernel error */
struct packet_type {
        __be16                  type;   /* This is really htons(ether_type). */
        struct net_device       *dev;   /* NULL is wildcarded here           */
        /*@ requires (skb != 0);*/
        int                     (*func) (struct sk_buff *,
                                         struct net_device *,
                                         struct packet_type *,
                                         struct net_device *);
        struct sk_buff          *(*gso_segment)(struct sk_buff *skb,
                                                int features);
        int                     (*gso_send_check)(struct sk_buff *skb);
        void                    *af_packet_priv;
        struct list_head        list;
};

typedef unsigned short  sa_family_t;
struct sockaddr {
        sa_family_t     sa_family;      /* address family, AF_xxx       */
        char            sa_data[14];    /* 14 bytes of protocol address */
};
/************** in.h ************/

struct in_addr {
        __be32  s_addr;
};
#define __SOCK_SIZE__   16              /* sizeof(struct sockaddr)      */

struct sockaddr_in {
  sa_family_t           sin_family;     /* Address family               */
  __be16                sin_port;       /* Port number                  */
  struct in_addr        sin_addr;       /* Internet address             */
};

#define INADDR_ANY              ((unsigned long int) 0x00000000)

/*define cho file ri2n_linux.h*/
#define ETH_ALEN        6               /* Octets in one ethernet addr   */
#define ETH_HLEN        14              /* Total octets in header.       */
#define ETH_ZLEN        60              /* Min. octets in frame sans FCS */
#define ETH_DATA_LEN    1500            /* Max. octets in payload        */
#define ETH_FRAME_LEN   1514            /* Max. octets in frame sans FCS */
#define ETH_FCS_LEN     4               /* Octets in the FCS             */
struct ethhdr {
        unsigned char   h_dest[ETH_ALEN];       /* destination eth addr */
        unsigned char   h_source[ETH_ALEN];     /* source ether addr    */
        __be16          h_proto;                /* packet type ID field */
} __attribute__((packed));


/**
    define for linux/spinlock_types.h
*/

#define SPINLOCK_MAGIC          0xdead4ead


#define RWLOCK_MAGIC            0xdeaf1eed

#define SPINLOCK_OWNER_INIT     ((void *)-1L)

#ifdef CONFIG_DEBUG_LOCK_ALLOC
# define SPIN_DEP_MAP_INIT(lockname)    .dep_map = { .name = #lockname }
#else
# define SPIN_DEP_MAP_INIT(lockname)
#endif
#define __RAW_SPIN_LOCK_UNLOCKED { 1 }



#ifdef CONFIG_DEBUG_SPINLOCK
# define __SPIN_LOCK_UNLOCKED(lockname)                                 \
        (spinlock_t)    {       .raw_lock = __RAW_SPIN_LOCK_UNLOCKED,   \
                                .magic = SPINLOCK_MAGIC,                \
                                .owner = SPINLOCK_OWNER_INIT,           \
                                .owner_cpu = -1,                        \
                                SPIN_DEP_MAP_INIT(lockname) }
#else
# define __SPIN_LOCK_UNLOCKED(lockname) \
        (spinlock_t)    {       .raw_lock = __RAW_SPIN_LOCK_UNLOCKED,   \
                                SPIN_DEP_MAP_INIT(lockname) }
#endif

/**
    define for linux/wait.h
*/
struct __wait_queue_head {
        spinlock_t lock;
        struct list_head task_list;
};
typedef struct __wait_queue_head wait_queue_head_t;

#define __WAIT_QUEUE_HEAD_INITIALIZER(name) {                           \
        .lock           = __SPIN_LOCK_UNLOCKED(name.lock),              \
        .task_list      = { &(name).task_list, &(name).task_list } }


#define DECLARE_WAIT_QUEUE_HEAD(name) \
        wait_queue_head_t name = __WAIT_QUEUE_HEAD_INITIALIZER(name)


/**
    define for page.h
*/

#ifndef _PPC_BOOT_PAGE_H
#define _PPC_BOOT_PAGE_H
/*
   4 * Copyright (C) 2001 PPC64 Team, IBM Corp
   5 *
   6 * This program is free software; you can redistribute it and/or
   7 * modify it under the terms of the GNU General Public License
   8 * as published by the Free Software Foundation; either version
   9 * 2 of the License, or (at your option) any later version.
  10 */

#ifdef __ASSEMBLY__
#define ASM_CONST(x) x
#else
#define __ASM_CONST(x) x##UL
#define ASM_CONST(x) __ASM_CONST(x)
#endif

/* PAGE_SHIFT determines the page size */
#define PAGE_SHIFT      12
#define PAGE_SIZE       (ASM_CONST(1) << PAGE_SHIFT)
#define PAGE_MASK       (~(PAGE_SIZE-1))

/* align addr on a size boundary - adjust address up/down if needed */
#define _ALIGN_UP(addr,size)    (((addr)+((size)-1))&(~((size)-1)))
#define _ALIGN_DOWN(addr,size)  ((addr)&(~((size)-1)))

/* align addr on a size boundary - adjust address up if needed */
#define _ALIGN(addr,size)     _ALIGN_UP(addr,size)

/* to align the pointer to the (next) page boundary */
#define PAGE_ALIGN(addr)        _ALIGN(addr, PAGE_SIZE)

#endif                          /* _PPC_BOOT_PAGE_H */



/**
    define for linux/skbuff.h
*/
#define MAX_SKB_FRAGS (65536/PAGE_SIZE + 2)

/**
    define for linux/mmzone.h
*/
#ifndef CONFIG_FORCE_MAX_ZONEORDER
#define MAX_ORDER 11
#else
#define MAX_ORDER CONFIG_FORCE_MAX_ZONEORDER
#endif                          /* CONFIG_FORCE_MAX_ZONEORDER */


/**
    define for linux/gfp.h
*/
#define __GFP_NOFAIL    ((gfp_t)0x800u) /* Retry for ever.  Cannot fail */

/*
static inline struct page *alloc_pages_current(gfp_t gfp, unsigned order)
{

        struct mempolicy *pol = current->mempolicy;

        if ((gfp & __GFP_WAIT) && !in_interrupt())
                cpuset_update_task_memory_state();
        if (!pol || in_interrupt() || (gfp & __GFP_THISNODE))
                pol = &default_policy;
        if (pol->policy == MPOL_INTERLEAVE)
                return alloc_page_interleave(gfp, order, interleave_nodes(pol));
        return __alloc_pages(gfp, order, zonelist_policy(gfp, pol));



     return page;

}
*/


/*
static inline struct page *
alloc_pages(gfp_t gfp_mask, unsigned int order)
{
        if (unlikely(order >= MAX_ORDER))
                return NULL;

        return alloc_pages_current(gfp_mask, order);
}

#define alloc_page(gfp_mask) alloc_pages(gfp_mask, 0)
*/
/******************** x86/acpi.h *******************/
#define ACPI_POWER_HID                  "LNXPOWER"
#define ACPI_PROCESSOR_HID              "ACPI0007"
#define ACPI_SYSTEM_HID                 "LNXSYSTM"
#define ACPI_THERMAL_HID                "LNXTHERM"
#define ACPI_BUTTON_HID_POWERF          "LNXPWRBN"
#define ACPI_BUTTON_HID_SLEEPF          "LNXSLPBN"
#define ACPI_VIDEO_HID                  "LNXVIDEO"
#define ACPI_BAY_HID                    "LNXIOBAY"

#define ACPI_SYSTEM_NOTIFY              0x1
#define ACPI_DEVICE_NOTIFY              0x2
#define ACPI_ALL_NOTIFY                 0x3
#define ACPI_MAX_NOTIFY_HANDLER_TYPE    0x3

#define ACPI_MAX_SYS_NOTIFY             0x7f

#define ACPI_EVENT_PMTIMER              0
#define ACPI_EVENT_GLOBAL               1
#define ACPI_EVENT_POWER_BUTTON         2
#define ACPI_EVENT_SLEEP_BUTTON         3
#define ACPI_EVENT_RTC                  4
#define ACPI_EVENT_MAX                  4
#define ACPI_NUM_FIXED_EVENTS           ACPI_EVENT_MAX + 1


typedef u8 acpi_owner_id;

/*union acpi_name_union {
        u32 integer;
        char ascii[4];
};*/
struct acpi_namespace_node {
        //union acpi_operand_object *object;      /* Interpreter object */
        u8 descriptor_type;     /* Differentiate object descriptor types */
        u8 type;                /* ACPI Type associated with this name */
        u8 flags;               /* Miscellaneous flags */
        acpi_owner_id owner_id; /* Node creator */
        //union acpi_name_union name;     /* ACPI Name, always 4 chars per ACPI spec */
        //struct acpi_namespace_node *child;      /* First child */
        //struct acpi_namespace_node *peer;       /* Peer. Parent if ANOBJ_END_OF_PEER_LIST set */

        /*
         * The following fields are used by the ASL compiler and disassembler only
         */
/*#ifdef ACPI_LARGE_NAMESPACE_NODE
        union acpi_parse_object *op;
        u32 value;
        u32 length;
#endif*/
};

typedef u32 acpi_status;        /* All ACPI Exceptions */
typedef u32 acpi_name;          /* 4-byte ACPI name */
//typedef char* acpi_string;      /* Null terminated ASCII string */
typedef int acpi_string;
typedef void* acpi_handle;

struct acpi_device_status {
        u32 present:1;
        u32 enabled:1;
        u32 show_in_ui:1;
        u32 functional:1;
        u32 battery_present:1;
        u32 reserved:27;
};


#define ACPI_ID_LEN 16
struct acpi_device_id {
        //char id[ACPI_ID_LEN];
        int id;
        long driver_data;
};

#define ACPI_MAX_HANDLES 10
struct acpi_handle_list {
        u32 count;
        acpi_handle handles[ACPI_MAX_HANDLES];
};

typedef
void (*acpi_notify_handler) (/*acpi_handle device, u32 value, void *context*/);

typedef int (*acpi_op_add) (/*struct acpi_device * device*/);
typedef int (*acpi_op_remove) (/*struct acpi_device * device, int type*/);
typedef int (*acpi_op_lock) (/*struct acpi_device * device, int type*/);
typedef int (*acpi_op_start) (/*struct acpi_device * device*/);
typedef int (*acpi_op_stop) (/*struct acpi_device * device, int type*/);
typedef int (*acpi_op_suspend) (/*struct acpi_device * device,
                                pm_message_t state*/);
typedef int (*acpi_op_resume) (/*struct acpi_device * device*/);
typedef int (*acpi_op_scan) (/*struct acpi_device * device*/);
typedef int (*acpi_op_bind) (/*struct acpi_device * device*/);
typedef int (*acpi_op_unbind) (/*struct acpi_device * device*/);
typedef int (*acpi_op_shutdown) (/*struct acpi_device * device*/);

struct acpi_device_ops {
        acpi_op_add add;
        acpi_op_remove remove;
        acpi_op_lock lock;
        acpi_op_start start;
        acpi_op_stop stop;
        acpi_op_suspend suspend;
        acpi_op_resume resume;
        acpi_op_scan scan;
        acpi_op_bind bind;
        //acpi_op_unbind unbind;
        acpi_op_shutdown shutdown;
};



struct acpi_driver {
        //char name[80];
        int name;
        //char class[80];
        int class;

        const struct acpi_device_id *ids; /* Supported Hardware IDs */
        struct acpi_device_ops ops;
        struct device_driver drv;
        struct module *owner;
};

//typedef char acpi_bus_id[5];
typedef int acpi_bus_id;

typedef unsigned long acpi_bus_address;

//typedef char acpi_hardware_id[15];
typedef int acpi_hardware_id;

//typedef char acpi_unique_id[9];
typedef int acpi_unique_id;

//typedef char acpi_device_name[40];
typedef int acpi_device_name;

//typedef char acpi_device_class[20];
typedef int acpi_device_class;

struct acpi_device_pnp {
        acpi_bus_id bus_id;     /* Object name */
        acpi_bus_address bus_address;   /* _ADR */
        acpi_hardware_id hardware_id;   /* _HID */
        //struct acpi_compatible_id_list *cid_list;       /* _CIDs */
        acpi_unique_id unique_id;       /* _UID */
        acpi_device_name device_name;   /* Driver-determined */
        acpi_device_class device_class; /*        "          */
};
struct acpi_device_flags {
        u32 dynamic_status:1;
        u32 hardware_id:1;
        u32 compatible_ids:1;
        u32 bus_address:1;
        u32 unique_id:1;
        u32 removable:1;
        u32 ejectable:1;
        u32 lockable:1;
        u32 suprise_removal_ok:1;
        u32 power_manageable:1;
        u32 performance_manageable:1;
        u32 wake_capable:1;     /* Wakeup(_PRW) supported? */
        u32 force_power_state:1;
        u32 reserved:19;
};


#define acpi_device_bid(d)      ((d)->pnp.bus_id)
#define acpi_device_adr(d)      ((d)->pnp.bus_address)
#define acpi_device_hid(d)      ((d)->pnp.hardware_id)
#define acpi_device_uid(d)      ((d)->pnp.unique_id)
#define acpi_device_name(d)     ((d)->pnp.device_name)
#define acpi_device_class(d)    ((d)->pnp.device_class)

#define acpi_driver_data(d)     ((d)->driver_data)
struct acpi_device {
        acpi_handle handle;
        //struct acpi_device *parent;
        //struct list_head children;
        //struct list_head node;
        //struct list_head wakeup_list;
        //struct list_head g_list;
        struct acpi_device_status status;
        struct acpi_device_flags flags;
        struct acpi_device_pnp pnp;
        //struct acpi_device_power power;
        //struct acpi_device_wakeup wakeup;
        //struct acpi_device_perf performance;
        //struct acpi_device_dir dir;
        struct acpi_device_ops ops;
        struct acpi_driver *driver;
        void *driver_data;
        //struct device dev;
        //struct acpi_bus_ops bus_ops;    /* workaround for different code path for hotplug */
        //enum acpi_bus_removal_type removal_type;        /* indicate for different removal type */
};

struct acpi_object_notify_handler {
        struct acpi_namespace_node *node;     /* Parent device */
        acpi_notify_handler handler;
        void *context;
};

/*
acpi_status
acpi_evaluate_integer(acpi_handle handle,
                      acpi_string pathname,
                      struct acpi_object_list *arguments, unsigned long *data);
*/
/*
struct acpi_object_notify_handler acpi_gbl_system_notify;
acpi_status
acpi_install_notify_handler(acpi_handle device,
                            u32 handler_type,
                            acpi_notify_handler handler, void *context)
{
    struct acpi_namespace_node *node;
    if (((handler_type & ACPI_SYSTEM_NOTIFY) &&
                     acpi_gbl_system_notify.handler) ||
                    ((handler_type & ACPI_DEVICE_NOTIFY) &&
                     acpi_gbl_device_notify.handler)) {
                        status = AE_ALREADY_EXISTS;
                        //goto unlock_and_exit;
    }

    if (handler_type & ACPI_SYSTEM_NOTIFY) {
                        acpi_gbl_system_notify.node = node;
                        acpi_gbl_system_notify.handler = handler;
                        acpi_gbl_system_notify.context = context;
    }

    if (handler_type & ACPI_DEVICE_NOTIFY) {
                        acpi_gbl_device_notify.node = node;
                        acpi_gbl_device_notify.handler = handler;
                        acpi_gbl_device_notify.context = context;
    }
}*/


typedef u32 (*acpi_event_handler) (void *context);

/*@
    ensures (\result == 0);
*/
acpi_status
  acpi_remove_fixed_event_handler(u32 event, acpi_event_handler handler);

/*@
    ensures (\result == 0);
*/
acpi_status
  acpi_install_fixed_event_handler(u32 event,
                                 acpi_event_handler handler, void *context);

/*@
    ensures (\result == 0);
*/
int acpi_bus_get_power(acpi_handle handle, int *state);

/*@
    ensures (\result == 0);
*/
int acpi_bus_set_power(acpi_handle handle, int state);


int acpi_bus_register_driver(struct acpi_driver *driver)
{
        int ret = 0;

//        if (acpi_disabled)
//                return -ENODEV;
//        driver->drv.name = driver->name;
//        driver->drv.bus = &acpi_bus_type;
//        driver->drv.owner = driver->owner;

        //ret = driver_register(&driver->drv);
        return ret;
}


/******************* i2c.h *******************************/
#define I2C_NAME_SIZE   20
#define KOBJ_NAME_LEN   20

#define I2C_SMBUS_BLOCK_MAX     32      /* As specified in SMBus standard */
union i2c_smbus_data {
        __u8 byte;
        __u16 word;
        __u8 block[I2C_SMBUS_BLOCK_MAX + 2]; /* block[0] is used for length */
                               /* and one more for user-space compatibility */
};

struct i2c_algorithm {
        int (*master_xfer)(/*struct i2c_adapter *adap,struct i2c_msg *msgs,
                           int num*/);
        int (*smbus_xfer) (/*struct i2c_adapter *adap, u16 addr,
                           unsigned short flags, char read_write,
                           u8 command, int size, union i2c_smbus_data * data*/);

        /* To determine what the adapter supports */
        u32 (*functionality) (/*struct i2c_adapter * */);
};

struct i2c_adapter {
        struct module *owner;
        unsigned int id;
        unsigned int class;
        const struct i2c_algorithm *algo; /* the algorithm to access the bus */
        void *algo_data;

        /* --- administration stuff. */
        int (*client_register)(/*struct i2c_client * */);
        int (*client_unregister)(/*struct i2c_client * */);

        /* data fields that are valid for all devices   */
        u8 level;                       /* nesting level for lockdep */
        //struct mutex bus_lock;
        //struct mutex clist_lock;

        int timeout;
        int retries;
        //struct device dev;              /* the adapter device */

        int nr;
        //struct list_head clients;
        //struct list_head list;
        char name[48];
        //struct completion dev_released;
};

struct i2c_driver {
        int id;
        unsigned int class;
        int (*attach_adapter)(/*struct i2c_adapter * */);
        int (*detach_adapter)(/*struct i2c_adapter * */);

        int (*detach_client)(/*struct i2c_client * */);

        int (*probe)(/*struct i2c_client * */);
        int (*remove)(/*struct i2c_client * */);

        void (*shutdown)(/*struct i2c_client * */);
        int (*suspend)(/*struct i2c_client *, pm_message_t mesg*/);
        int (*resume)(/*struct i2c_client * */);

        int (*command)(/*struct i2c_client *client,unsigned int cmd, void *arg*/);

        //struct device_driver driver;
        //struct list_head list;
};

struct i2c_client {
        unsigned short flags;           /* div., see below              */
        unsigned short addr;            /* chip address - NOTE: 7bit    */
                                        /* addresses are stored in the  */
                                        /* _LOWER_ 7 bits               */
        char name[I2C_NAME_SIZE];
        struct i2c_adapter *adapter;    /* the adapter we sit on        */
        struct i2c_driver *driver;      /* and our access routines      */
        int usage_count;                /* How many accesses currently  */
                                        /* to the client                */
        //struct device dev;              /* the device structure         */
        int irq;                        /* irq issued by device (or -1) */
        char driver_name[KOBJ_NAME_LEN];
        //struct list_head list;
        //struct completion released;
};

/**************************************************/
#endif
