(* slicing/constructACFG.mli *)
(* Copyright (C) 2007-2010 Yonezawa Lab, The University of Tokyo *)

val construct_acfg : (Cexpr.stmt_t list) -> (Slicingstructure.node list) -> (Slicingstructure.graph_type_slicing) list

val get_list_func : unit -> string list

val print_stmt : Cexpr.stmt_t -> unit

val print_def : Cexpr.stmt_t -> unit

val htbl_uses_infos : (string, (string, string list) Hashtbl.t) Hashtbl.t

val htbl_gens_infos : (string, (string, Slicingstructure.couple_node_var list) Hashtbl.t) Hashtbl.t

val htbl_stmts_for_ddg_infos : (string, Cexpr.stmt_t list) Hashtbl.t

val print_gens :  (string, (string, (Slicingstructure.node * string) list) Hashtbl.t) Hashtbl.t -> unit

val print_gen :  (string, (Slicingstructure.node * string) list) Hashtbl.t -> unit

val get_couple_all : unit -> (Slicingstructure.node list * Slicingstructure.edge list) list

val get_input_slicing : unit -> Slicingstructure.node list

val htbl_statement_infos : ( string, ( Cexpr.stmt_t * int ) ) Hashtbl.t

val print_statement_infos : unit -> unit

val check_function_call : Cexpr.expr_t -> (bool * string * ( ( int * string ) list ) )
