(* slicing/slicingstructure.mli *)
(* Copyright (C) 2007-2010 Yonezawa Lab, The University of Tokyo *)

(* type of node *)
type type_node = 
    | NODE_ASGN
    | NODE_ASGN_V
    | NODE_IF
    | NODE_GOTO
    | NODE_LABEL
    | NODE_STMT
    | NODE_OTHER

(* node of graph *)
type node = NodeV of string * string * type_node
           

(* type of edge *)
type edge_type = 
	| ACFG_TRUE
	| ACFG_FALSE       
	| CDG
	| DDG
	| PDT
        | SDG 
        | KOBO 
        | BO 
        | OTHER		

(* edge *)
type edge = Edge of node * node * edge_type * int

(* graph *)
type graph_type_slicing = ((node list) * (edge list))

(* Tao kieu dung trong xay dung DDG slicingstructure.mli constructACFG.mli constructCDG.mli constructDDG.mli slicing.mli *)
type couple_node_var = node * string

(*=========================================================*)

val get_name_function : Cexpr.expr_t -> string

val find_parent : node -> edge list -> node list

val get_list_var_from_expr : Cexpr.expr_t -> string list

val pause : string -> unit

val is_mem_of_list_node : node -> node list -> bool

val equal_nodes : node -> node -> bool

val print_node : node -> unit

val print_edge : edge -> unit

val print_nodes : node list -> unit

val print_edges : edge list -> unit

val print_graph : (node list * edge list) -> unit

