(* utils/simpleLogging.ml *)
(* Copyright (C) 2007-2010 Yonezawa Lab, The University of Tokyo *)

type facility = Debug | Info | Notice | Warn | Error | Crit | Alert | Emerg;;


module Log = 
    struct 
        let string_of_level (l : facility) : string = (
            match l with 
            | Emerg -> "EMERG"
            | Error -> "ERROR"
            | Warn -> "WARNING"
            | Debug -> "DEBUG"
            | Info -> "INFO"
            | Notice -> "NOTICE"
            | Crit -> "CRIT"
            | Alert -> "ALERT"
        )
        let log (l : facility) (msg : string) : unit = ( 
            print_endline ("[" ^ (Printf.sprintf "%10.0f" (Unix.time ())) ^ "] "
                           ^ (string_of_level l) ^ " : " ^ (msg)))
        let init () = () 
        let close () = () 
        let set_new_log_level (l : facility)  = () 
        let debug msg = log Debug msg
        let info msg = log Info msg
        let notice msg = log Notice msg
        let warn msg = log Warn msg
        let error msg = log Error msg
        let crit msg = log Crit msg
        let alert msg = log Alert msg
        let emerg msg = log Emerg msg
    end;;
