#include <assert.h>

#define NUM_PDE		(1024)

typedef unsigned int	u32;
typedef u32		page_entry_t;

page_entry_t *page_entries_1;
page_entry_t *page_entries_2;
page_entry_t *page_entries_3;

/*@
	$requires ((pde_index >= 0) && (pde_index < NUM_PDE));
 */
page_entry_t get_pde_1(u32 pde_index)
{
	return page_entries_1[pde_index];
}

/*@
	$requires ((pde_index >= 0) && (pde_index < NUM_PDE));
 */
page_entry_t get_pde_2(u32 pde_index)
{
	return page_entries_2[pde_index];
}

/*@
	$requires ((pde_index >= 0) && (pde_index < NUM_PDE));
 */
page_entry_t get_pde_3(u32 pde_index)
{
	return page_entries_2[pde_index];
}

/*@
    $ensures($valid(page_entries_1));
    $ensures($valid(page_entries_2));
    $ensures($valid(page_entries_3));
 */
void page_entries_init(void);


void main(void)
{
	page_entry_t pde1;
	page_entry_t pde2;
	page_entry_t pde3;

	page_entries_init();

	pde1 = get_pde_1(1);
	pde2 = get_pde_2(1);
	pde3 = get_pde_3(1);
}
