#!/bin/bash

# Test driver script driven by Hudson

# I (Hajime Fujita) would like to thank Mr.Akihiro Nomura for
# giving me a Perl script for cutting C filenames from testcases.desc

RESULTFILE="hudson_inter_test_result.xml"

if [ "$CLAPDIR" = "" ]; then
    echo "CLAPDIR not set!"
    exit 1
fi

set -e

CFILES=`cat testcases.desc | perl -e 'while (<>) { print "$_\n" foreach m/[^ ]+\.c/g }' | egrep '.*\.c$'`

set +e

for c in $CFILES; do 
    $CLAPDIR/clap ps -I $CLAPDIR/include -c $c
done

set -e

cat testcases.desc | sed -e 's/\.c\([ |]\)/\.inter.c\1/g' > inter_tests.desc

make -C $CLAPDIR/testsuite/

$CLAPDIR/testsuite/test_suite \
--clap=$CLAPDIR/clap \
--include-dir=$CLAPDIR/include \
-o $RESULTFILE \
--xml \
inter_tests.desc
